/*
 * Telecomanda.c
 *
 * Created: 17.05.2019 17:05:25
 * Author : Cristi
 */ 

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include "usart.h"

int counter = 0;

void led_signal_transmit()
{
	counter %= 10;
	if(counter == 5) {
		PORTD |= (1 << PD7);
	} else if(counter == 0) {
		PORTD &= ~(1 <<PD7);
	}
	counter++;
	_delay_ms(100);
}

void led_signal_transmit2()
{
	PORTD |= (1 << PD7);
	_delay_ms(100);
	PORTD &= ~(1 << PD7);
	_delay_ms(100);
}

int main(void)
{
	/* Set input buttons */
	DDRB &= ~(1 << PB0);
	DDRB &= ~(1 << PB1);
	DDRB &= ~(1 << PB2);
	DDRB &= ~(1 << PB3);
	DDRB &= ~(1 << PB4);
	DDRB &= ~(1 << PB5);
	
	DDRD &= ~(1 << PD4);
	DDRD &= ~(1 << PD5);
	
	/* Activate pull-up resistors */
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB5);
	
	PORTD |= (1 << PD4);
	PORTD |= (1 << PD5);
	
	/* Set output leds */
	DDRD |= (1 << PD7);
	
	/* Power off led */
	PORTD &= ~(1 << PD7);
	
	/* Initialize usart communication */
	USART0_init();
	
	/* Simple commands */
	char forward_100 = 'x';
	char forward_75 = 'y';
	char forward_50 = 'z';
	char forward_25 = 'w';
	char backward_100 = 'a';
	char backward_50 = 'b';
	char left = 'l';
	char right = 'r';
	
	/* Composed commands */
	char forward_100_right = 'c';
	char forward_75_right = 'd';
	char forward_50_right = 'e';
	char forward_25_right = 'f';
	char forward_100_left = 'g';
	char forward_75_left = 'h';
	char forward_50_left = 'i';
	char forward_25_left = 'j';
	
	char backward_100_right = 'k';
	char backward_50_right = 'o';
	char backward_100_left = 'm';
	char backward_50_left = 'n';
	
	
	
	
    while (1) 
    {
		
		if ((PINB & (1 << PB0)) == 0 && (PIND & (1 << PD5)) == 0) {
			USART0_transmit(forward_100_right);
			led_signal_transmit();
		} else if ((PINB & (1 << PB1)) == 0 && (PIND & (1 << PD5)) == 0) {
			USART0_transmit(forward_75_right);
			led_signal_transmit();
		} else if ((PINB & (1 << PB2)) == 0 && (PIND & (1 << PD5)) == 0) {
			USART0_transmit(forward_50_right);
			led_signal_transmit();
		} else if ((PINB & (1 << PB3)) == 0 && (PIND & (1 << PD5)) == 0) {
			USART0_transmit(forward_25_right);
			led_signal_transmit();
		} else if ((PINB & (1 << PB0)) == 0 && (PIND & (1 << PD4)) == 0) {
			USART0_transmit(forward_100_left);
			led_signal_transmit();
		} else if ((PINB & (1 << PB1)) == 0 && (PIND & (1 << PD4)) == 0) {
			USART0_transmit(forward_75_left);
			led_signal_transmit();
		} else if ((PINB & (1 << PB2)) == 0 && (PIND & (1 << PD4)) == 0) {
			USART0_transmit(forward_50_left);
			led_signal_transmit();
		} else if ((PINB & (1 << PB3)) == 0 && (PIND & (1 << PD4)) == 0) {
			USART0_transmit(forward_25_left);
			led_signal_transmit();
		} else if ((PINB & (1 << PB4)) == 0 && (PIND & (1 << PD5)) == 0) {
			USART0_transmit(backward_100_right);
			led_signal_transmit();
		} else if ((PINB & (1 << PB4)) == 0 && (PIND & (1 << PD4)) == 0) {
			USART0_transmit(backward_100_left);
			led_signal_transmit();
		} else if ((PINB & (1 << PB5)) == 0 && (PIND & (1 << PD5)) == 0) {
			USART0_transmit(backward_50_right);
			led_signal_transmit();
		} else if ((PINB & (1 << PB5)) == 0 && (PIND & (1 << PD4)) == 0) {
			USART0_transmit(backward_50_left);
			led_signal_transmit();
		} else if((PINB & (1 << PB0)) == 0) {
			USART0_transmit(forward_100);
			led_signal_transmit();
		} else if ((PINB & (1 << PB1)) == 0) {
			USART0_transmit(forward_75);
			led_signal_transmit();
		} else if ((PINB & (1 << PB2)) == 0) {
			USART0_transmit(forward_50);
			led_signal_transmit();
		} else if ((PINB & (1 << PB3)) == 0) {
			USART0_transmit(forward_25);
			led_signal_transmit();
		} else if ((PINB & (1 << PB4)) == 0) {
			USART0_transmit(backward_100);
			led_signal_transmit();
		} else if ((PINB & (1 << PB5)) == 0) {
			USART0_transmit(backward_50);
			led_signal_transmit();
		} else if ((PIND & (1 << PD4)) == 0) {
			USART0_transmit(left);
			led_signal_transmit();
		} else if ((PIND & (1 << PD5)) == 0) {
			USART0_transmit(right);
			led_signal_transmit();
		} else {
			counter = 0;
			PORTD &= ~(1 <<PD7);
		}
    }
}

